function drawGraphReachLimContinue(States ,subtractTransitions, addTransitions, limitNumber,...
    limitType,excleList,TransExtraValues,maxSpaceUsed,transistionNames )
% Takes nine inputs, makes a figure
% this method is called from petNetCoverTreeGUI.m and itself.
% The inputs need to be in a specific order
% input 1 is a list of structs that are made by makeStatesCover.m or
% makeStatesDepthLim.m or makeStatesPlaceValLim.m
% input 2 is a matrix where each row represents the tokens removed from
% each place by a trasition. Contains only negative values or 0
% input 3 is a matrix where each row represents the tokens added to
% each place by a trasition. Contains only positive values or 0
% input 4 is used to make new states by the continueFromSelectedMarking
% internal method. it is a number.
% input 5 is used to make new states by the continueFromSelectedMarking
% internal method. it is a string to a switch statement.
% input 6 is a list of index numbers for transitions to ignore when making
% new states. used in continueFromSelectedMarking
% input 7 is a matrix, containing the extra costs for each transition.
% input 8 is a result from makeStatesCover.m or makeStatesDepthLim.m or makeStatesPlaceValLim.m
% it is used to decide the size of the state rectangles
% input 9 is an array of strigs that need to have as many elements as there
% are rows in input 2 and 3. It is the names fo each transition.
% makes use of makeStatesCover.m, makeStatesDepthLim.m and makeStatesPlaceValLim.m



tnames=transistionNames;
% stae measurements
len= 5+ maxSpaceUsed*12 +5; % the lenght of a state rectangle
heig = 50; % % vertical height of the boxes
VertSpace=150; % vertical space between levels of states
horizSpace=20; % horizontal space bettween states

transitionArrow_headsize_ajuster=500;

adjustment= 8000; % used for ajusting the relative size of text in states

transNameMaxSize=0; % get the biggest transition name
for i =1:length(transistionNames)
    tmp=string(transistionNames(i));
    if length(char(tmp))>transNameMaxSize
        transNameMaxSize=length(char(tmp));
    end
end

tmp= size(TransExtraValues);
numberOfExtraValuesPerState=tmp(2);

singleExtraLen=50; % the lenght of one extra state rectangle
totExtraLen = numberOfExtraValuesPerState*singleExtraLen;

numberOfLevels=0; % find the max depth of the tree
for i = 1 :length(States)
    if States(i).depth > numberOfLevels
        numberOfLevels=States(i).depth;
    end
end

numberOfStatesAtEachLevel= zeros(1,numberOfLevels);  % get number of states at each level
for i = 1 :length(States)
    numberOfStatesAtEachLevel(States(i).depth)=numberOfStatesAtEachLevel(States(i).depth)+1;
end
[valOfMaxLev , indexOfMaxLev] =max(numberOfStatesAtEachLevel);

% horisontally the graph is centered on the zero coordinate

maxLen= valOfMaxLev*(len+horizSpace+totExtraLen);

spaceOfLevel= zeros(1,numberOfLevels);
for i = 1 :length(spaceOfLevel)
    if numberOfStatesAtEachLevel(i) == valOfMaxLev
        spaceOfLevel(i)=horizSpace ;
    else
        adj=((numberOfStatesAtEachLevel(i)-1)*(len+horizSpace+totExtraLen))/100 ;
        spaceOfLevel(i)=horizSpace + (maxLen/(adj)) ;
    end
end

horisontalCoordinate= zeros(1,numberOfLevels);
for i = 1 :length(horisontalCoordinate)
    if numberOfStatesAtEachLevel(i) >1
        totalLengthOfDepthLevel= (numberOfStatesAtEachLevel(i) -1)*(len+spaceOfLevel(i)+totExtraLen);
        horisontalCoordinate(i)= 0 - (totalLengthOfDepthLevel/2 );
    end
end


f =figure;
movegui(f,'northeast');
axes('Units', 'normalized', 'Position', [0 0 1 1])

% get axes size for text zoom function
axis([ (min(horisontalCoordinate)-len) , (abs(min(horisontalCoordinate))+len) , (-(numberOfLevels*300)-heig) , (-300+heig) ]);

ax = axis;


%each state is given coordinates
for i = 1 :length(States) % adds central coordinates to eache state
    if numberOfStatesAtEachLevel(States(i).depth) ==1
        States(i).coordinates=[0 -States(i).depth*(heig+ VertSpace)] ; % if there is only one state at his level, the horizontal coordinate will be 0
    elseif numberOfStatesAtEachLevel(States(i).depth) >1
        States(i).coordinates=[horisontalCoordinate(States(i).depth) -States(i).depth*(heig+ VertSpace)] ;
        horisontalCoordinate(States(i).depth)= horisontalCoordinate(States(i).depth) +(len+ spaceOfLevel(States(i).depth)+totExtraLen);
    end
    
end


hold on;
for i = 1 :length(States) % draw rectangles
    switch States(i).type % choose colour based on type
        case 'N'
            colour= [0.5 1 0.5];
        case 'D'
            colour= [1 1 0];
        case 'E'
            colour= [1 0.5 0.5];
        otherwise
            disp('error')
    end
    rek=rectangle('Position',[States(i).coordinates(1)-(len/2) , States(i).coordinates(2)-(heig/2)...
        , len , heig ],'FaceColor',colour , 'ButtonDownFcn' ,@markStateMarking );
    
    rek.UserData = States(i).ID;
    States(i).drawStateRectangle=rek;
    
    States(i).exValRecktangles=[];
    States(i).exValTxt=[];
    
    tmp3= size(TransExtraValues);
    for j= 1:tmp3(2)
        tmpRek=rectangle('Position',[States(i).coordinates(1)+(len/2)+(j-1)*singleExtraLen , States(i).coordinates(2)-(heig/2)...
            , singleExtraLen , heig ],'FaceColor','none' , 'ButtonDownFcn' ,@markStateMarking );
        tmpRek.UserData = States(i).ID;
        States(i).exValRecktangles=[States(i).exValRecktangles tmpRek];
        
        tmptxt=text( States(i).coordinates(1)-(len/2)+(j-1)*singleExtraLen + len+5 , States(i).coordinates(2) ,...
            char(string(States(i).extraValues(j) )) , 'ButtonDownFcn' ,@markStateMarking );
        tmptxt.FontSize= ((adjustment/1.1)/(ax(4)-ax(3)));
        tmptxt.UserData=States(i).ID;
        States(i).exValTxt=[States(i).exValTxt tmptxt];
        
    end
    
    txtChar='';
    elementCount=0;
    for j = 1:length(States(i).marking)
        tmp= str2num ( char(States(i).marking(j)) );
        if char(States(i).marking(j)) == 'W'
            elementCount=elementCount+1;
            if elementCount ==1
                txtChar= strcat( txtChar , '\omega' , 'p_' , num2str(j) ) ;
            elseif elementCount >1
                tmp2=strcat({' + '} , {'\omega'}, {'p_' }, {num2str(j)}  ) ;
                txtChar=strcat(txtChar ,tmp2 );
            end
        elseif tmp>0
            elementCount=elementCount+1;
            if elementCount ==1
                txtChar= strcat( txtChar , char(States(i).marking(j)) , 'p_' , num2str(j) ) ;
            elseif elementCount >1
                tmp2=strcat({' + '} , { char(States(i).marking(j)) }, {'p_' }, {num2str(j)}  ) ;
                txtChar=strcat(txtChar ,tmp2 );
            end
        end
    end
    
    txt=text( States(i).coordinates(1)-(len/2)+5 , States(i).coordinates(2) ,...
        char( txtChar ) , 'ButtonDownFcn' ,@markStateMarking );
    
    txt.FontSize= ((adjustment/1.1)/(ax(4)-ax(3)));
    txt.UserData=States(i).ID;
    
    
    
    States(i).drawStateText=txt;
    
end


% drawing transition elements
% the vertical level of the textboxes for duplicate transitions are a little
% different than the other transition textboxes. This is to detect
% overlapping boxes when showing redirected transitions.
transGroup1=[];% arrows that point to normal states, these are always visible
transGroup2=[];% arrows that point to duplicate states, these are visible to begin with
transGroup3=[];% redirected arrows that point to normal states, these are made hidden to begin with
% all groups contain a list of structs that contain, a quiver arrow, a
% rectangle and text
for i = 1 :length(States) % draw transition arrows
    if ~isnan(States(i).parent_ID); % only draw is the state has a parent state
        p1 = States(States(i).parent_ID).coordinates; % starting point
        p1(2) = p1(2)-heig/2;
        p2 = States(i).coordinates; %ending point
        p2(2) = p2(2)+heig/2;
        dp = p2-p1; % difference
        arrw=quiver(p1(1),p1(2),dp(1),dp(2),0,'color',[0 0 1]);
        % quiver arrows have different sizes depending on the lenght of the arrow
        % divide the quiver property MaxHeadSize by the length of the arrow, then the heads will be the same size.
        x=[p1(1) p2(1)];
        y=[p1(2) p2(2)];
        d = diff([x(:) y(:)]);
        total_length = sum(sqrt(sum(d.*d,2)));
        arrw.MaxHeadSize = (arrw.MaxHeadSize/total_length)*transitionArrow_headsize_ajuster;
        
        tRekLen=transNameMaxSize*12; % the lenght of a transition rectangle
        
        rek=rectangle('Position',[p1(1)+(dp(1)/1.4)-tRekLen/2 ,  p1(2)+(dp(2)/1.4)-15 ...
            , tRekLen , 32 ],...
            'FaceColor','w');
        
        transText = char(transistionNames(States(i).transToThis));
        
        drawnTxt=text( p1(1)+(dp(1)/1.4)-tRekLen/2+3 , p1(2)+(dp(2)/1.4)+15-15 ...
            ,transText , 'Color', 'k' );
        % choose what group to put them in
        switch States(i).type
            case 'N'
                arrw.Color = 	[0 0.3 0];
                drawnTxt.Color = 	[0 0.3 0];
                trans.arrow= arrw;
                trans.rektangle= rek;
                trans.text= drawnTxt;
                transGroup1=[transGroup1 trans];
            case 'E'
                arrw.Color = 	[0.3 0 0];
                drawnTxt.Color = 	[0.3 0 0];
                trans.arrow= arrw;
                trans.rektangle= rek;
                trans.text= drawnTxt;
                transGroup1=[transGroup1 trans];
            case 'D' % for every duplicate, make two arrows,
                arrw.Color = [0.5 0.5 0];
                drawnTxt.Color = 	[0.5 0.5 0];
                trans.arrow= arrw;
                trans.rektangle= rek;
                trans.text= drawnTxt;
                transGroup2=[transGroup2 trans];
                
                p1 = States(States(i).parent_ID).coordinates; % p1 will be the same regardless
                p1(2) = p1(2)-heig/2;
                colour=[0.5 0.5 0];
                for j = 1 :length(States)
                    tmp = States(i).marking == States(j).marking;
                    if (all(tmp(:) > 0)) &&  (States(j).type == 'N' | States(j).type == 'E')
                        p2 = States(j).coordinates;
                        p2(2) = p2(2)+heig/2;
                        
                        break
                    end
                end
                dp = p2-p1;
                arrw=quiver(p1(1),p1(2),dp(1),dp(2),0,'color',colour); % draws the arrow
                x=[p1(1) p2(1)];
                y=[p1(2) p2(2)];
                d = diff([x(:) y(:)]);
                total_length = sum(sqrt(sum(d.*d,2)));
                arrw.MaxHeadSize = (arrw.MaxHeadSize/total_length)*transitionArrow_headsize_ajuster;
                
                rek=rectangle('Position',[p1(1)+(dp(1)/1.8)-tRekLen/2 ,  p1(2)+(dp(2)/1.8)-15 ...
                    , tRekLen , 32 ],...
                    'FaceColor','w');
                
                transText = char(transistionNames(States(i).transToThis));
                
                drawnTxt=text( p1(1)+(dp(1)/1.8)-tRekLen/2+3 , p1(2)+(dp(2)/1.8)+15-15 ,...
                    transText , 'Color',[0.5 0.5 0] );
                
                arrw.Visible='off';
                rek.Visible='off';
                drawnTxt.Visible='off';
                trans.arrow= arrw;
                trans.rektangle= rek;
                trans.text= drawnTxt;
                transGroup3=[transGroup3 trans];
                
            otherwise
                disp('error')
        end
    end
end

% buttons for the bottom row
hideDupButton = uicontrol('Style', 'pushbutton', 'String', 'hide duplicates',...
    'Position', [10 10 120 30],...
    'FontSize', 11,...
    'Callback', @hideDuplicateButton);

showDupButton = uicontrol('Style', 'pushbutton', 'String', 'show duplicates',...
    'Position', [130 10 120 30],...
    'FontSize', 11,...
    'Callback', @showDuplicateButton);

searchButton = uicontrol('Style', 'pushbutton', 'String', 'search',...
    'Position', [250 10 80 30],...
    'FontSize', 11,...
    'Callback', @searchForMarking);

continueButton = uicontrol('Style', 'pushbutton', 'String', 'continue',...
    'Position', [330 10 80 30],...
    'FontSize', 11,...
    'Callback', @continueFromSelectedMarking);

axis equal

h = zoom; % get handle to zoom utility
set(h,'ActionPostCallback',@zoomCallBack);
set(h,'Enable','on');

ax = axis;

for ii =1:length(States)
    
    set(States(ii).drawStateText,'FontSize',adjustment/(ax(4)-ax(3)));
    
    for jj= 1: length(States(ii).exValRecktangles)
        set(States(ii).exValTxt(jj),'FontSize',adjustment/(ax(4)-ax(3)));
    end
end

for ii =1:length(transGroup1)
    set(transGroup1(ii).text ,'FontSize',adjustment/(ax(4)-ax(3)) );
end
for ii =1:length(transGroup2)
    set(transGroup2(ii).text ,'FontSize',adjustment/(ax(4)-ax(3)) );
end
for ii =1:length(transGroup3)
    set(transGroup3(ii).text ,'FontSize',adjustment/(ax(4)-ax(3)) );
end

%--------------------functions-----------

% everytime you zoom , this function is executed
    function zoomCallBack(~, evd)
        
        ax = axis(evd.Axes); % get axis size
        
        
        for ii =1:length(States)
            
            set(States(ii).drawStateText,'FontSize',adjustment/(ax(4)-ax(3)));
            
            for jj= 1: length(States(ii).exValRecktangles)
                set(States(ii).exValTxt(jj),'FontSize',adjustment/(ax(4)-ax(3)));
            end
            
        end
        
        for ii =1:length(transGroup1)
            set(transGroup1(ii).text ,'FontSize',adjustment/(ax(4)-ax(3)) );
        end
        for ii =1:length(transGroup2)
            set(transGroup2(ii).text ,'FontSize',adjustment/(ax(4)-ax(3)) );
        end
        for ii =1:length(transGroup3)
            set(transGroup3(ii).text ,'FontSize',adjustment/(ax(4)-ax(3)) );
        end
        
    end

    function hideDuplicateButton(btn,event) % use to hide group 2 and show group 3
        
        for ii = 1 :length(transGroup2)
            % arrows that point to duplicate states, these are visible to begin with
            transGroup2(ii).arrow.Visible='off';
            transGroup2(ii).rektangle.Visible='off';
            transGroup2(ii).text.Visible='off';
        end
        for ii = 1 :length(transGroup3)
            % redirected arrows that point to duplicate states, these are made hidden to begin with
            transGroup3(ii).arrow.Visible='on';
            transGroup3(ii).rektangle.Visible='on';
            transGroup3(ii).text.Visible='on';
        end
        
        for ii = 1 :length(States)
            if States(ii).type == 'D'
                States(ii).drawStateText.Visible='off';
                States(ii).drawStateRectangle.Visible='off';
                for jj= 1: length(States(ii).exValRecktangles)
                    States(ii).exValRecktangles(jj).Visible='off';
                    States(ii).exValTxt(jj).Visible='off';
                end
            end
        end
        
    end

    function showDuplicateButton(btn,event) % use to hide group 3 and show group 2
        
        for ii = 1 :length(transGroup3)
            % arrows that point to duplicate states, these are visible to begin with
            transGroup3(ii).arrow.Visible='off';
            transGroup3(ii).rektangle.Visible='off';
            transGroup3(ii).text.Visible='off';
        end
        for ii = 1 :length(transGroup2)
            % redirected arrows that point to duplicate states, these are made hidden to begin with
            transGroup2(ii).arrow.Visible='on';
            transGroup2(ii).rektangle.Visible='on';
            transGroup2(ii).text.Visible='on';
        end
        
        for ii = 1 :length(States)
            if States(ii).type == 'D'
                States(ii).drawStateText.Visible='on';
                States(ii).drawStateRectangle.Visible='on';
                for jj= 1: length(States(ii).exValRecktangles)
                    States(ii).exValRecktangles(jj).Visible='on';
                    States(ii).exValTxt(jj).Visible='on';
                end
            end
        end
    end


markingOfClickedRectangle=[0]; % variables for selecting states on mouseclick
lastClickedState=States(1)

idOfPrevRectanglesClicked=[];
    function markStateMarking(src,event ) % changes the outline of state rectangles when clicked
        
        States(src.UserData).drawStateRectangle.LineWidth = 2;
        for ii = 1:length(idOfPrevRectanglesClicked) % set old markings to default value
            States(idOfPrevRectanglesClicked(ii)).drawStateRectangle.LineWidth = 0.5;
        end
        disp(idOfPrevRectanglesClicked)
        idOfPrevRectanglesClicked=src.UserData;
        lastClickedState=States(src.UserData);
        
        markingOfClickedRectangle=States(src.UserData).marking;
    end

    function searchForMarking(src,event)
        % changes the outline of state rectangles based on full search
        
        defaultInput=markingOfClickedRectangle(1);
        for ii = 2: length(markingOfClickedRectangle)
            defaultInput=strcat(defaultInput,{' '},markingOfClickedRectangle(ii));
        end
        dialougeAnswer = inputdlg({'input marking to search for'},'search input',[1 40],{char(defaultInput)});
        
        for ii = 1:length(idOfPrevRectanglesClicked) % set old markings to default value
            States(idOfPrevRectanglesClicked(ii)).drawStateRectangle.LineWidth = 0.5;
        end
        
        searchFor = strsplit(char(dialougeAnswer))
        
        for ii = 1:length(States)
            tmp = searchFor == States(ii).marking;
            if all(tmp(:) > 0)
                
                States(ii).drawStateRectangle.LineWidth = 2;
                idOfPrevRectanglesClicked=[idOfPrevRectanglesClicked ii];
                markingOfClickedRectangle=States(ii).marking;
            end
        end
        
    end

    function continueFromSelectedMarking(src,event)
        % method for continuing tree generation from the selected state
        
        if length(markingOfClickedRectangle)>1
            % convert to int array of values
            intMarking=zeros(size(markingOfClickedRectangle));
            sizeinput =size(markingOfClickedRectangle);
            for i=1:sizeinput(2)
                if char(markingOfClickedRectangle(i)) == 'W'
                    intMarking(i)= inf;
                else
                    intMarking(i) = str2num(char(markingOfClickedRectangle(i)));
                end
            end
            
            switch limitType
                case 'coverability'
                    coverType='normal'
                    
                    [States2,maxSpaceUsed2]= makeStatesCover(intMarking,subtractTransitions,addTransitions,...
                        excleList,coverType);
                    drawGraphReachLimContinue(States2 ,subtractTransitions, addTransitions, limitNumber,limitType,...
                        excleList,TransExtraValues,maxSpaceUsed2, tnames )
                    
                case 'coverability_extra'
                    coverType='extra'
                    
                    [States2,maxSpaceUsed2] =makeStatesCover(intMarking,subtractTransitions,addTransitions,....
                        excleList,coverType);
                    drawGraphReachLimContinue(States2 ,subtractTransitions, addTransitions,...
                        limitNumber,limitType,excleList,TransExtraValues,maxSpaceUsed2,tnames )
                    
                case 'reachabilityWithDepthLimit'
                    if isfield(lastClickedState ,'extraValues' )
                        extra_initial2=lastClickedState.extraValues;
                    else
                        extra_initial2=[];
                    end
                    
                    %the new home marking will be denoted as depth 1, no need to change the limit
                    [States2,maxSpaceUsed2]= makeStatesDepthLim(intMarking , subtractTransitions, addTransitions, limitNumber,excleList ,...
                        TransExtraValues,extra_initial2 ,lastClickedState.history )
                    
                    drawGraphReachLimContinue(States2 ,subtractTransitions, addTransitions, limitNumber,...
                        limitType,excleList,TransExtraValues,maxSpaceUsed2,tnames  )
                    
                    
                case 'reachabilityWithValueLimit'
                    
                    if isfield(lastClickedState ,'extraValues' )
                        extra_initial2=lastClickedState.extraValues;
                    else
                        extra_initial2=[];
                    end

                    % add the imit to the highest value in the new home marking
                    newLimitNumber=limitNumber+ max(intMarking);
                    [States2,maxSpaceUsed2]=makeStatesPlaceValLim(intMarking , subtractTransitions, addTransitions,...
                        newLimitNumber, excleList , TransExtraValues,extra_initial2 ,lastClickedState.history);
                    
                    drawGraphReachLimContinue(States2 ,subtractTransitions, addTransitions,...
                        limitNumber,limitType,excleList,TransExtraValues,maxSpaceUsed2,tnames )
            end
            
        end
        
    end

end