function Result = findActiveTransitions(marking,subTransMatrix,excludeList)
% takes an array of strings as the marking.
% uses a marking and a matrix of the subtraction values of all
% transitions, and returns the index values of all possible transitions
% from the given marking

intMarking=[];
sizeinput =size(marking);
for i=1:sizeinput(2)
    if char(marking(i)) == 'W'
        intMarking = [intMarking inf];
    else
        intMarking = [intMarking str2num(char(marking(i)))];
    end
end

transitions=[];
for i=1:size(subTransMatrix)
    
    x=( intMarking + subTransMatrix(i,1:end));
    y = x >= 0 ;
    y= all(y(:) > 0);
    
    if length(excludeList)>0
        if ismember(i, excludeList(:))
            continue
        end
    end
    
    if y > 0
        transitions = [transitions i];
    end
end

Result = transitions   ;
end